#ifndef __SERIALCOMM_LL_H_
#define __SERIALCOMM_LL_H_

#include "stm32f4xx_hal.h"

/* Definition for SERIALCOMM_USARTx clock resources */
#define SERIALCOMM_USARTx                           USART2
#define SERIALCOMM_USARTx_BAUDRATE                  115200
#define SERIALCOMM_USARTx_CLK_ENABLE()              __HAL_RCC_USART2_CLK_ENABLE()
#define SERIALCOMM_DMAx_CLK_ENABLE()                __HAL_RCC_DMA1_CLK_ENABLE()
#define SERIALCOMM_USARTx_RX_GPIO_CLK_ENABLE()      __HAL_RCC_GPIOA_CLK_ENABLE()
#define SERIALCOMM_USARTx_TX_GPIO_CLK_ENABLE()      __HAL_RCC_GPIOA_CLK_ENABLE() 

#define SERIALCOMM_USARTx_FORCE_RESET()             __HAL_RCC_USART2_FORCE_RESET()
#define SERIALCOMM_USARTx_RELEASE_RESET()           __HAL_RCC_USART2_RELEASE_RESET()

/* Definition for SERIALCOMM_USARTx Pins */
#define SERIALCOMM_USARTx_TX_PIN                    GPIO_PIN_2
#define SERIALCOMM_USARTx_TX_GPIO_PORT              GPIOA
#define SERIALCOMM_USARTx_TX_AF                     GPIO_AF7_USART2
#define SERIALCOMM_USARTx_RX_PIN                    GPIO_PIN_3
#define SERIALCOMM_USARTx_RX_GPIO_PORT              GPIOA
#define SERIALCOMM_USARTx_RX_AF                     GPIO_AF7_USART2

/* Definition for SERIALCOMM_USARTx's DMA */
#define SERIALCOMM_USARTx_TX_DMA_INSTANCE           DMA1_Stream6
#define SERIALCOMM_USARTx_TX_DMA_CHANNEL            DMA_CHANNEL_4
//#define SERIALCOMM_USARTx_TX_DMA_REQUEST            DMA_REQUEST_2
#define SERIALCOMM_USARTx_RX_DMA_INSTANCE           DMA1_Stream5
#define SERIALCOMM_USARTx_RX_DMA_CHANNEL            DMA_CHANNEL_4
//#define SERIALCOMM_USARTx_RX_DMA_REQUEST            DMA_REQUEST_2

/* Definition for SERIALCOMM_USARTx's NVIC */
#define SERIALCOMM_USARTx_DMA_TX_IRQn               DMA1_Stream6_IRQn
#define SERIALCOMM_USARTx_DMA_TX_IRQHandler         DMA1_Stream6_IRQHandler
#define SERIALCOMM_USARTx_DMA_RX_IRQn               DMA1_Stream5_IRQn
#define SERIALCOMM_USARTx_DMA_RX_IRQHandler         DMA1_Stream5_IRQHandler
#define SERIALCOMM_USARTx_IRQn                      USART2_IRQn
#define SERIALCOMM_USARTx_IRQHandler                USART2_IRQHandler

/* Size of Transmission buffer */
#ifndef SERIALCOMM_TXBUFFERSIZE
#define SERIALCOMM_TXBUFFERSIZE                      (256)
#endif
/* Size of Reception buffer */
#ifndef SERIALCOMM_RXBUFFERSIZE
#define SERIALCOMM_RXBUFFERSIZE                      (256)
#endif

#endif
